## emacs25 25.2+1

=== modules/mod-test/Makefile ===
# Test GNU Emacs modules.

# Copyright 2015-2017 Free Software Foundation, Inc.

# This file is part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.

ROOT = ../..
EMACS = $(ROOT)/src/emacs

CC      = gcc
LD      = gcc
LDFLAGS =

# On MS-Windows, say "make SO=dll" to build the module
SO      = so
# -fPIC is a no-op on Windows, but causes a compiler warning
ifeq ($(SO),dll)
CFLAGS  = -std=gnu99 -ggdb3 -Wall
else
CFLAGS  = -std=gnu99 -ggdb3 -Wall -fPIC
endif

all: mod-test.$(SO)

%.$(SO): %.o
	$(LD) -shared $(LDFLAGS) -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -I$(ROOT)/src -c $<

check:
	$(EMACS) -batch -l ert -l test.el -f ert-run-tests-batch-and-exit

=== test/indent/Makefile ===
RM=rm
EMACS=../../src/emacs

all: clean $(addsuffix .test,$(wildcard *.*))

clean:
	-$(RM) -f *.new

# TODO:
# - mark the places where the indentation is known to be incorrect,
#   and allow either ignoring those errors or not.
%.test: %
	$(EMACS) --batch $< \
	    --eval '(indent-region (point-min) (point-max) nil)' \
	    --eval '(write-region (point-min) (point-max) "$<.new")'
	diff -u -B $< $<.new

=== test/automated/data/flymake/Makefile ===
# Makefile for flymake tests

CC_OPTS = -Wall

## Recent gcc (e.g. 4.8.2 on RHEL7) can automatically colorize their output,
## which can confuse flymake.  Set GCC_COLORS to disable that.
## This only seems to be an issue in batch mode, where you would not
## normally use flymake, so it seems like just avoiding the issue
## in this test is fine.  Set flymake-log-level to 3 to investigate.
check-syntax:
	GCC_COLORS= $(CC) $(CC_OPTS) ${CHK_SOURCES}

# eof

=== debian/changelog ===
emacs25 (25.2+1-6) unstable; urgency=high

  * Block remote code execution via enriched text.  Add
    0012-A-remote-execution-exploit-via-enriched-text-has-bee.patch to
    fix the problem.  Thanks to David Bremner for the alert and
    Salvatore Bonaccorso for reporting the problem to Debian.
    (Closes: 875447)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 11 Sep 2017 21:51:49 -0500

emacs25 (25.2+1-5) unstable; urgency=medium

  * Build with -O0 on arm64 to avoid FTBS.  Without this the build
    segfaults in marker.c when trying to construct c-by.el.
    cf. https://lists.gnu.org/archive/html/emacs-devel/2017-03/msg00798.html
    Thanks to Gianfranco Costamagna for reporting the bug and Barry
    Warsaw for suggesting the workaround. (Closes: 868165)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 31 Jul 2017 23:34:05 -0500

emacs25 (25.2+1-4) unstable; urgency=medium

  * Disable eieio-test-method-order-list-6.  Its behavior is
    unpredictable, and it was causing the armhf build to fail:
      https://debbugs.gnu.org/27878
      https://debbugs.gnu.org/24503#21
    Add 0011-Disable-eieio-test-method-order-list-6.patch to fix the
    problem.  Thanks to Glen Morris for pointing out the previous report.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 30 Jul 2017 22:31:30 -0500

emacs25 (25.2+1-3) unstable; urgency=medium

  * Actually run tests by default (fix DEB_BUILD_OPTIONS nocheck test)
    Fix the inverted logic.  Thanks to John Paul Adrian Glaubitz for
    reporting the problem.  (Closes: 869328)

  * Completely remove gconf support.  Build --without-gconf for the
    emacs25 flavor (as we already do for lucid and nox), since GConf
    has been deprecated for years.  Thanks to intrigeri for reporting
    the issue. (Closes: 869085)

  * Fix README.Debian news entry for
    0008-Don-t-provide-openssl-s_client-as-an-option-for-ssl-.patch.

  * Fix memory alignment problem causing FTBS on m68k.  Thanks to John
    Paul Adrian Glaubitz for reporting the problem and providing an
    earlier fix. (Closes: 868868)

  * Don't downcase lookup paths in elisp-mode-tests.  This caused the
    tests to fail under sbuild when the test path contained uppercase
    characters.  Add
    0010-Don-t-downcase-real-xref-in-elisp-mode-tests.patch to fix the
    problem.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 29 Jul 2017 11:58:36 -0500

emacs25 (25.2+1-2) unstable; urgency=medium

  * emacsXY-common: directly depend on install-info.  Since Emacs
    qualifies as an info reader (Debian Policy 12.2).  This should
    make sure the info index is correctly created/updated at install
    time.  Thanks to Francesco Potortì and NIIBE Yutaka for reporting
    the problem. (Closes: 850808, 863359)

  * Build all flavors from common build-src via VPATH.  Instead of
    building each flavor from scratch in a completely independent
    debian/build-FLAVOR directory, create debian/build-src and then
    configure each build-FLAVOR via VPATH.  Then the first flavor
    built will handle all of the common bootstrapping, and subsequent
    flavors will build much more quickly.

  * Migrate to debhelper 10.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 11 Jul 2017 15:46:35 -0500

emacs25 (25.2+1-1) unstable; urgency=medium

  * Merge upstream version 25.2.

  * Update debian/ for 25.2.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 01 Jul 2017 14:35:18 -0500

=== debian/control ===
Source: emacs25
Section: editors
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: bsd-mailx | mailx, libncurses5-dev, texinfo, liblockfile-dev, librsvg2-dev,
 dbus-x11,
 gnupg-agent,
 libgif-dev | libungif4-dev,
 libtiff-dev,
 procps,
 xaw3dg-dev,
 libpng-dev, libjpeg-dev, libm17n-dev, libotf-dev,
 libgpm-dev [linux-any], libdbus-1-dev,
 autoconf, automake, autotools-dev, dpkg-dev (>> 1.10.0), quilt (>= 0.42),
 debhelper (>= 9), libxaw7-dev, sharutils, imagemagick, libgtk-3-dev,
 libgnutls28-dev, libxml2-dev, libselinux1-dev [linux-any],
 libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 libmagick++-6.q16-dev,
 libacl1-dev,
 liboss4-salsa-dev [hurd-i386 kfreebsd-i386 kfreebsd-amd64],
 zlib1g-dev
Homepage: http://www.gnu.org/software/emacs/
Standards-Version: 3.7.2

Package: emacs25-lucid
Architecture: any
Depends: emacs25-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: emacs25, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs25-common-non-dfsg
Conflicts: emacs25, emacs25-nox
Replaces: emacs25, emacs25-nox
Description: GNU Emacs editor (with Lucid GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with support for a graphical user
 interface based on the Lucid toolkit (instead of the GTK+ interface
 provided by the emacs25 package).  Until some known GTK+
 problems are fixed, this version may help avoid crashing Emacs during
 an emacsclient disconnect.  See
 https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=567934 and
 https://bugzilla.gnome.org/show_bug.cgi?id=85715 for more
 information.

Package: emacs25-lucid-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs25-lucid-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs25-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs25-lucid
 package.

Package: emacs25-nox
Architecture: any
Depends: emacs25-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: emacs25, editor, emacsen, info-browser, mail-reader, news-reader
Suggests: emacs25-common-non-dfsg
Conflicts: emacs25, emacs25-lucid
Replaces: emacs25, emacs25-lucid
Description: GNU Emacs editor (without GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs compiled without support for X,
 and provides only a text terminal interface.

Package: emacs25-nox-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs25-nox-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs25-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs25-nox
 package.

Package: emacs25
Architecture: any
Depends: emacs25-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: editor, emacsen, info-browser, mail-reader, news-reader
Suggests: emacs25-common-non-dfsg
Conflicts: emacs25-lucid, emacs25-nox
Replaces: emacs25-lucid, emacs25-nox
Description: GNU Emacs editor (with GTK+ GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ (instead of the Lucid toolkit provided by the
 emacs25-lucid package).

Package: emacs25-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs25-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs25
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs25 package.

Package: emacs25-bin-common
Architecture: any
Depends: emacs25-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: GNU Emacs editor's shared, architecture dependent files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture dependent infrastructure
 that's shared by emacs25, emacs25-lucid, and emacs25-nox.

Package: emacs25-common
Architecture: all
Depends: emacsen-common (>= 2.0.8), install-info, ${shlibs:Depends}, ${misc:Depends}
Recommends: emacs25-el
Suggests: emacs25-el, emacs25-common-non-dfsg, ncurses-term
Conflicts: emacs25-el (<< ${source:Version}), cedet, eieio, speedbar, gnus-bonus-el
Breaks: apel (<< 10.8+0.20120427-4)
Description: GNU Emacs editor's shared, architecture independent infrastructure
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture independent infrastructure
 that's shared by emacs25, emacs25-lucid, and emacs25-nox.

Package: emacs25-el
Architecture: all
Depends: emacs25-common (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This file is licensed under the terms of the Gnu Public License.
# With the one additional provision that Ian Jackson's name may not be
# removed from the file.

# Copyright 1994,1995 Ian Jackson
# Copyright 2004-2005 Jrme Marant <jerome@debian.org>
# Copyright 1998-2015 Rob Browning <rlb@defaultvalue.org>

# Originally copied from the GNU Hello Debian rules file (1.3).
# Modified for emacs by Mark Eichin <eichin@kitten.gen.ma.us>.
# Debhelper support added via one of Joey Hess' example files.
# See the debian/changelog for further historical information.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL := /bin/bash
quilt := QUILT_PATCHES=debian/patches QUILT_PATCHES_PREFIX=y quilt
pf := set -o pipefail

# This package uses debian/source/format 3.0 (quilt).

# For now we assume that emacs' versioning scheme is always
# MAJOR.MINORtinyrev where MAJOR and MINOR are integers and tinyrev is
# an optional lowercase letter (or letters).  We also assume that
# upstream uses a numbering scheme that sorts in a "Debian friendly"
# way.  So far that's always been true.  If it becomes false, some of
# the values below will have to be set manually.

# (You might imagine that a VPATH build would allow us to avoid having
#  to copy the entire source tree for each of the three builds, but it
#  turns out that the emacs build process doesn't entirely respect the
#  VPATH and modifies all kinds of files in the srcdir (e.g. *.elc,
#  *.map, etc.).

# The official upstream version defined by AC_INIT in configure.in.
upstream_ver := $(shell debian/upstream-version)
ifeq (,$(upstream_ver))
  $(error 'Unable to find upstream version number.')
endif

# This must be the version that's actually used at runtime for things
# like load-path.  It may not be the same as the upstream version
# (i.e. when you have upstream 20.5a, the functional version may still
# be 20.5), so sometimes we may have to do this by hand.
runtime_ver := $(shell $(pf); echo $(upstream_ver) | perl -pe 's/[a-z]+$$//o')
major_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/\..*$$//o')
minor_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/^[^.]*\.//o')

# The name of the Debian source package
src_name := $(shell $(pf); dpkg-parsechangelog | egrep '^Source:')
src_name := $(shell $(pf); echo $(src_name) | perl -pe 's/Source:\s+//o')

# The version from the changelog (i.e. 20.5-1)
debian_ver := $(shell $(pf); dpkg-parsechangelog | egrep '^Version:')
debian_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/Version:\s+//o')

# The Debian revision (i.e. the 1 from 20.5-1)
# Always everything after the last '-'
debian_rev := $(shell $(pf); echo $(debian_ver) | perl -pe 's/.*-//o')

# Might be 21.3, or it might be 21.3+1 if we've had to have more than
# one re-release of the upstream source (rare, but it happens), or if
# we have to split the package for DFSG purposes.  Always everything
# before the last '-'
debsrc_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/-[^-]+$$//o')

# The flavor (i.e. emacs21) currently matches the source package name.
flavor := $(src_name)

info_subdir := emacs-$(major_ver)

######################################################################
# Customizable variables

bin_priority := 28

# This might also be something like 2006-09-09 for snapshots.
menu_ver := $(major_ver)

######################################################################

# Should these be exported like this (as autotools-dev recommends for
# the two vars below) or not?
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

# As recommended by /usr/share/doc/autotools-dev/README.Debian.gz.
# Handle cross-compiling and don't make ./configure guess.
export DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# FOR AUTOCONF 2.52 AND NEWER ONLY
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Without this, the build dies in marker.c when trying to create c-by.el
ifeq ($(DEB_HOST_ARCH),arm64)
  export DEB_CFLAGS_MAINT_APPEND := -O0
endif

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -Wall
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(joblimit))
  joblimit := 1
endif

target := $(DEB_HOST_GNU_TYPE)
movemail_bin := usr/lib/emacs/$(runtime_ver)/$(target)/movemail

# Info files that are going to show up in the main dir.
main_dir_info_files := efaq.info

# Files that the build stage depends on (may also be listed in other vars).
persistent_autogen_build_files := debian/control debian/copyright
nonpersistent_autogen_build_files :=

# These files must always exist, i.e. can't ever be cleaned.
persistent_autogen_install_files :=

nonpersistent_autogen_install_files := \
  debian/$(flavor)-bin-common.lintian-overrides \
  debian/$(flavor)-bin-common.postinst \
  debian/$(flavor)-bin-common.prerm \
  debian/$(flavor)-common.README.Debian \
  debian/$(flavor)-common.docs \
  debian/$(flavor)-common.lintian-overrides \
  debian/$(flavor)-common.postinst \
  debian/$(flavor)-common.prerm \
  debian/$(flavor)-term.desktop \
  debian/$(flavor)-nox.README.Debian \
  debian/$(flavor)-nox.lintian-overrides \
  debian/$(flavor)-nox.postinst \
  debian/$(flavor)-nox.prerm \
  debian/$(flavor)-lucid.README.Debian \
  debian/$(flavor)-lucid.desktop \
  debian/$(flavor)-lucid.lintian-overrides \
  debian/$(flavor)-lucid.postinst \
  debian/$(flavor)-lucid.prerm \
  debian/$(flavor).README.Debian \
  debian/$(flavor).desktop \
  debian/$(flavor).lintian-overrides \
  debian/$(flavor).postinst \
  debian/$(flavor).prerm

autogen_build_files := \
  $(nonpersistent_autogen_build_files) $(persistent_autogen_build_files)

autogen_install_files := \
  $(nonpersistent_autogen_install_files) $(persistent_autogen_install_files)

persistent_autogen_files := \
  $(persistent_autogen_build_files) $(persistent_autogen_install_files)

nonpersistent_autogen_files := \
  $(nonpersistent_autogen_build_files) $(nonpersistent_autogen_install_files)


# Build directories
pkgdir_common := $(CURDIR)/debian/$(flavor)-common
pkgdir_bin_common := $(CURDIR)/debian/$(flavor)-bin-common
pkgdir_x := $(CURDIR)/debian/$(flavor)
pkgdir_nox := $(CURDIR)/debian/$(flavor)-nox
pkgdir_lucid := $(CURDIR)/debian/$(flavor)-lucid
pkgdir_el := $(CURDIR)/debian/$(flavor)-el

install_dir_x := $(CURDIR)/debian/install-x
install_dir_nox := $(CURDIR)/debian/install-nox
install_dir_lucid := $(CURDIR)/debian/install-lucid

local_lpath := /etc/$(flavor):/etc/emacs
local_lpath := $(local_lpath):/usr/local/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/local/share/emacs/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/site-lisp

# Installation local_lpath
local_lpath_install \
  := $(pkgdir_common)/$(subst :,:$(pkgdir_common)/,$(local_lpath))

define testdir
  dh_testdir debian/emacsVER.postinst
endef

# If we ever need to do the stripping outside of dh_strip, just add an
# INSTALL_STRIP="-s" to the make vars below.

define emacs_inst
  $(MAKE) -C debian/$(1) install \
    DESTDIR=$(2) \
    infodir=/usr/share/info/emacs-$(major_ver) \
    localstatedir=/var
endef

# If we ever need it, we can create a copy that doesn't assume ./debian/
define deb_sub
  perl -p \
    -e "s|\@PKG_NAME\@|$(pkg_name)|go;" \
    -e "s|\@MAJOR_VERSION\@|$(major_ver)|go;" \
    -e "s|\@MINOR_VERSION\@|$(minor_ver)|go;" \
    -e "s|\@FULL_VERSION\@|$(runtime_ver)|go;" \
